// 
//
/*
Алгоритм работы управления
Кнопка
  - один клик переход по эффектам вперед (+1)
  - двойной клик перехад по эффектам назад (-1)
  При переходе в другой эффект контроль энкодера сбрасывается в единицу.
Энкодер
  - вращение регулирует текущий параметр, текущего эффекта
  - один клик переход по параметрам текущего эффекта вперед (+1)
  - двойной клик переход по параметрам текущего эффекта назад (-1)
  - Если период изменения Тмах становится меньше чем Тмин, то значение Тмин проталкивается вниз и ...

Передача параметров на мигание светодиодом происходит через переменную P_svdiod
*/
void controlTick()
{
     // Энкодер
    enc.tick();
    if (enc.isRight()) 
    { P_svdiod=1;
switch (eff) {
  case 0:
        HSV_contr (true);
  break;
  case 1:
  case 3:
  case 4:
   Kelvin_control (true); 
  break;
  case 2:
    RGB_control (true);
  break;
 case 5:
    HSV_c (true);
  break;
   case 6:
    RGB_c (true);
  break;
  case 7:
  Kelvin_c(true);
  break;
  case 8 :
  Collor_c (true);
  break;

}
eeprom_wr=true;
    };
    
     
    if (enc.isLeft()) {
      P_svdiod=1;
switch (eff) {
  case 0:
        HSV_contr ( false);
  break;

  case 1:
  case 3:
  case 4:
    Kelvin_control (false);
  break;
  case 2:
    RGB_control (false);
  break;
case 5:
    HSV_c (false);
  break;
   case 6:
    RGB_c (false);
  break;
  case 7:
  Kelvin_c(false);
  break;
  case 8 :
  Collor_c (false);
  break;
   
}
eeprom_wr=true;
    };


if (enc.isSingle())    { contr++; if (contr > N_contr) contr=1; 
P_svdiod=contr+20;}; 
if (enc.isDouble())    { contr--; if (contr < 1 ) contr=N_contr; 
P_svdiod=contr+20;}; 
    
    // кнопка
    btn.tick();
    if (btn.isSingle())   {  eff=eff+1; contr=1;
    if (eff>N_eff) {eff=0;};
      P_svdiod=eff+21 ;
     eeprom_wr=true;
     erom_read ();
     }; 
    if (btn.isDouble())   {  eff=eff-1; contr=1;
    if (eff<0 ) { eff=N_eff; };  
    P_svdiod=eff+21;
     eeprom_wr=true;   erom_read ();
      };  
    if (btn.isHolded())   {   def_set () ;  P_svdiod=3; };
}

void HSV_contr( bool bm)
{
if (bm)
{
switch (contr) {
  case 1:
     Brightness++; 
  break;
  case 2:
    V++;
  break;
  case 3:
    speedK_min++;
    speedTemp=speedK_min;
    if (speedK_min > speedK_max ) {speedK_max=speedK_min ; P_svdiod=3; };
  break;
  case 4:
   speedK_max++;
   speedTemp=speedK_max;
  break;
  
}
}
else
{
  switch (contr) {
  case 1:
    
    Brightness--; 
    break;
  case 2:
   V--;
    break;
    case 3:
   speedK_min--;
   speedTemp=speedK_min;
    break;
  case 4:
     speedK_max--;
    speedTemp=speedK_max;
    if (speedK_min > speedK_max ) { speedK_min=speedK_max ; P_svdiod=3; };
    break;
}
}
// проверяем корректность данных
if (Brightness > 254 ) {Brightness=254; P_svdiod=2;};
if (Brightness < 1 ) {Brightness=1; P_svdiod=2; };

if ( V > 255 ) {V=255; P_svdiod=2; };
if ( V < 0 ) {V=0; P_svdiod=2; };
}

void Kelvin_control (bool bm)
{
if (bm)
{
switch (contr) {
  case 1 :
Brightness++; 
  break;
  case  2:
     BrightnessRGB++; 
    break;
   case 3:
   speedK_min++;
   speedTemp=speedK_min;
    if (speedK_min > speedK_max ) { speedK_max=speedK_min ; P_svdiod=3; };
    break;
  case 4:
     speedK_max++;
    speedTemp=speedK_max;
    break;
}
}
else
{
  switch (contr) {
  case 1 :
Brightness--; 
  break;
  case  2:
     BrightnessRGB--; 
    break;
   case 3:
   speedK_min--;
   speedTemp=speedK_min;
    break;
  case 4:
     speedK_max--;
    speedTemp=speedK_max;
    if (speedK_min > speedK_max ) { speedK_min=speedK_max ; P_svdiod=3; };
    break;
}
}  
// проверяем корректность данных
if (Brightness > 254 ) {Brightness=254; P_svdiod=2; };
if (Brightness < 1 ) {Brightness=1; P_svdiod=2; };
if (BrightnessRGB > 255 ) { BrightnessRGB=254; P_svdiod=2; };
if (BrightnessRGB < 1 ) { BrightnessRGB=1; P_svdiod=2; };

}
// 2 mode
void RGB_control( bool bm)
{
if (bm)
{
switch (contr) {
  case 1:
     Brightness++; 
    break;
  case 2:
    BrightnessRGB++;
    break;
    case 3:
    contr=1;
    break;
  case 4:
    contr=1;
    break;
  
}
}
else
{
  switch (contr) {
  case 1:
    
    Brightness--; 
    break;
  case 2:
    BrightnessRGB--;
    break;
    case 3:
    contr=1;
    break;
  case 4:
    contr=1;
    break;
}
}
// проверяем корректность данных
if (Brightness > 255 ) { Brightness=254; P_svdiod=2; };
if (Brightness < 1 ) { Brightness=1; P_svdiod=2; };
if (BrightnessRGB > 255 ) {BrightnessRGB=254; P_svdiod=2; };
if (BrightnessRGB < 1 ) { BrightnessRGB=1; P_svdiod=2; };
}

// 6 mode
void RGB_c( bool bm)
{
if (bm)
{
switch (contr) {
  case 1:
     Brightness++; 
    break;
  case 2:
    R++;
    break;
    case 3:
    G++;
    break;
  case 4:
    B++;
    break;
  
}
}
else
{
  switch (contr) {
  case 1:
    
    Brightness--; 
    break;
  case 2:
    R--;
    break;
    case 3:
    G--;
    break;
  case 4:
    B--;
    break;
}
}
// проверяем корректность данных
if (Brightness > 255 ) { Brightness=254; P_svdiod=2; };
if (Brightness < 5 ) { Brightness=5; P_svdiod=2; };
if ( R > 255 ) { R=255; P_svdiod=2; };
if ( R < 0 ) { R=0; P_svdiod=2; };
if ( G > 255 ) { G=255; P_svdiod=2; };
if ( G < 0 ) { G=0; P_svdiod=2; };
if ( B > 255 ) { B=255; P_svdiod=2; };
if ( B < 0 ) { B=0; P_svdiod=2; };
}
void HSV_c (bool bm)
{ 
  if (bm)
{
switch (contr) {
  case 1:
     Brightness++; 
    break;
  case 2:
    H++;
    break;
    case 3:
    S++;
    break;
  case 4:
    V++;
    break;
  
}
}
else
{
  switch (contr) {
  case 1:
    
    Brightness--; 
    break;
  case 2:
    H--;
    break;
    case 3:
    S--;
    break;
  case 4:
    V--;
    break;
}
}
// проверяем корректность данных
if (Brightness > 255 ) { Brightness=254; P_svdiod=2; };
if (Brightness < 5 ) {Brightness=5; P_svdiod=2; };
if ( H > 255 ) {H=255; P_svdiod=2; };
if ( H < 0 ) {H=0; P_svdiod=2; };
if ( S > 255 ) {S=255; P_svdiod=2; };
if ( S < 0 ) {V=0; P_svdiod=2; };
if ( V > 255 ) {V=255; P_svdiod=2; };
if ( V < 0 ) {V=0; P_svdiod=2; };

}

void Kelvin_c (bool bm)
{ 
  if (bm)
{
switch (contr) {
  case 1:
     Brightness++; 
    break;
  case 2:
    BrightnessRGB++;
    break;
    case 3:
    Temp=Temp+100;
    break;
  case 4:
    contr=1;
    break;
  
}
}
else
{
  switch (contr) {
  case 1:
    
    Brightness--; 
    break;
  case 2:
    BrightnessRGB--;
    break;
    case 3:
    Temp=Temp-100;
    break;
  case 4:
    contr=1;
    break;
}
}
// проверяем корректность данных
if (Brightness > 255 ) { Brightness=254; P_svdiod=2; };
if (Brightness < 1 ) {Brightness=5; P_svdiod=2; };
if ( Temp > 9999 ) {Temp=9999; P_svdiod=2; };
if ( Temp < 1000 ) {Temp=1000; P_svdiod=2; };
if ( BrightnessRGB > 255 ) {BrightnessRGB=255; P_svdiod=2; };
if ( BrightnessRGB < 1 ) {BrightnessRGB=1; P_svdiod=2; };

}

void Collor_c (bool bm)
{ 
  if (bm)
{
switch (contr) {
  case 1:
     Brightness++; 
    break;
  case 2:
    BrightnessRGB++;
    break;
    case 3:
    Color=Color+10;
    break;
  case 4:
    contr=1;
    break;
  
}
}
else
{
  switch (contr) {
  case 1:
    
    Brightness--; 
    break;
  case 2:
    BrightnessRGB--;
    break;
    case 3:
    Color=Color-10;
    break;
  case 4:
    contr=1;
    break;
}
}
// проверяем корректность данных
if (Brightness > 255 ) { Brightness=254; P_svdiod=2; };
if (Brightness < 5 ) {Brightness=5; P_svdiod=2; };
if ( Color > 1530 ) {Temp=1530; P_svdiod=2; };
if ( Color < 1 ) {Color=1; P_svdiod=2; };
if ( BrightnessRGB > 255 ) {BrightnessRGB=255; P_svdiod=2; };
if ( BrightnessRGB < 0 ) {BrightnessRGB=0; P_svdiod=2; };

}