/*
Хранимые в памяти переменные и карта памяти
тип переменной / имя переменной / количество занимаемых байт / диапазон адресов /
int8_t eff  1   0    //  для хранения переводить в тип byte
byte  Brightness        1   1...10 // яркость белого канала для соответствующего эффекта
byte  BrightnessRGB     1   11...16 // яркость РЖБ для некоторых эффектов ( 1, 2, 3, 4, 6, 7)
byte  BrightnessRGB     1   86 // 8 eff
byte  H                 1   17...18 // для режимов 0, 5
byte  S                 1   19...20 // для режимов 0,5
byte  V                 1   21...22 // для режимов 0 и 5
byte  H_min             1   23
byte  H_max             1   24
byte  S_min             1   25
byte  S_max             1   26
int   Temp              2   27...28 //  7
float Tcollor_min       4   29...32
float Tcollor_max       4   33...36
float speedK_min        4   37...40, 41...44, 45...48, 49...52 // для режимов 0, 1, 3, 4
float speedK_max        4   53...56, 57...60, 61...64, 65...68
byte  R                 1   69
byte  G                 1   70
byte  B                 1   71
float speedR            4   72...75
float speedG            4   76...79
float speedB            4   80...83
int   Color             2   84...85

*/



// чтение из памяти данных для режима
void erom_read ()
{
    switch (eff)
    {
    case 0:
   
        Brightness=EEPROM.readByte(1);
        V = EEPROM.readByte(21);
        H_min = EEPROM.readByte(23);
        H_max = EEPROM.readByte(24);
        S_min= EEPROM.readByte(25);
        S_max= EEPROM.readByte(26);
        speedK_min = EEPROM.readFloat(37);
        speedK_max = EEPROM.readFloat(53);
        break;
    
    case 1:
        Brightness=EEPROM.readByte(2);
        BrightnessRGB = EEPROM.readByte(11);
        Tcollor_min = EEPROM.readFloat(29);
        Tcollor_max = EEPROM.readFloat(33);
        speedK_min = EEPROM.readFloat(41);
        speedK_max = EEPROM.readFloat(57);
        break;

    case 2:
        Brightness=EEPROM.readByte(3);
        BrightnessRGB = EEPROM.readByte(12);
        speedR = EEPROM.readFloat(72);
        speedG = EEPROM.readFloat(76);
        speedB = EEPROM.readFloat(80);
       
            break;
    case 3:
        Brightness=EEPROM.readByte(4);
        BrightnessRGB = EEPROM.readByte(13);
        speedK_min = EEPROM.readFloat(45);
        speedK_max = EEPROM.readFloat(61);
        break;

    case 4:
        Brightness=EEPROM.readByte(5);
        BrightnessRGB = EEPROM.readByte(14);
        speedK_min = EEPROM.readFloat(49);
        speedK_max = EEPROM.readFloat(65);
        break;
    case 5:
         Brightness=EEPROM.readByte(6);
         H = EEPROM.readByte(18);
         S = EEPROM.readByte(20);
         V = EEPROM.readByte(22);
    
        break;
    case 6:
        Brightness=EEPROM.readByte(7);
        BrightnessRGB = EEPROM.readByte(15);
        R = EEPROM.readByte(69);
        G = EEPROM.readByte(70);
        B = EEPROM.readByte(71);
    
        break;
    case 7:
        Brightness=EEPROM.readByte(8);
        BrightnessRGB = EEPROM.readByte(16);
        Temp = EEPROM.readInt(27);
        break;
        
    case 8:
        Brightness=EEPROM.readByte(9);
        BrightnessRGB = EEPROM.readByte(86);
        Color = EEPROM.readInt(84);
    
        break;
    }

}

void erom_up (byte eff2)
{
    /*
    bool update(int address, uint8_t value);
bool updateByte(int address, uint8_t value);
bool updateInt(int address, uint16_t value);
bool updateLong(int address, uint32_t value);
bool updateFloat(int address, float value);
bool updateDouble(int address, double);
*/

    switch (eff2)
    {
    case 0:
   
       EEPROM.updateByte( 1, Brightness);
       EEPROM.updateByte( 21, V); 
       EEPROM.updateByte( 23,H_min);
       EEPROM.updateByte( 24, H_max);
       EEPROM.updateByte( 25 , S_min );
       EEPROM.updateByte( 26 , S_max );
       EEPROM.updateFloat( 37 , speedK_min );
       EEPROM.updateFloat( 53 , speedK_max );
        break;
    
    case 1:
       EEPROM.updateByte( 2, Brightness  );
       EEPROM.updateByte( 11, BrightnessRGB );
       EEPROM.updateFloat( 29 ,  Tcollor_min );
       EEPROM.updateFloat( 33 ,  Tcollor_max ) ; 
       EEPROM.updateFloat( 41 , speedK_min  );
       EEPROM.updateFloat( 57 , speedK_max );
        break;

    case 2:
        EEPROM.updateByte( 3,Brightness );
        EEPROM.updateByte( 12 , BrightnessRGB );
        EEPROM.updateFloat( 72 , speedR ) ;
        EEPROM.updateFloat( 76 , speedG );
        EEPROM.updateFloat( 80 , speedB );
       
            break;
    case 3:
        EEPROM.updateByte( 4 , Brightness );
        EEPROM.updateByte( 13 , BrightnessRGB );
        EEPROM.updateFloat( 45 , speedK_min );
        EEPROM.updateFloat( 61 , speedK_max );
        break;

    case 4:
        EEPROM.updateByte( 5 , Brightness);
        EEPROM.updateByte( 14 , BrightnessRGB);
        EEPROM.updateFloat( 49 , speedK_min );
        EEPROM.updateFloat( 65 , speedK_max);
        break;
    case 5:
         EEPROM.updateByte( 6 , Brightness);
         EEPROM.updateByte( 18 , H );
         EEPROM.updateByte( 20 , S );
         EEPROM.updateByte( 22 , V );
    
        break;
    case 6:
        EEPROM.updateByte( 7 , Brightness);
        EEPROM.updateByte( 15 , BrightnessRGB );
        EEPROM.updateByte( 69 , R );
        EEPROM.updateByte( 70 , G );
        EEPROM.updateByte( 71 , B );
    
        break;
    case 7:
        EEPROM.updateByte( 8 , Brightness );
        EEPROM.updateByte( 16 , BrightnessRGB );
        EEPROM.updateInt( 27 , Temp );
        break;
        
    case 8:
        EEPROM.updateByte( 9 , Brightness );
        EEPROM.updateByte( 86 , BrightnessRGB );
        EEPROM.updateInt ( 84 , Color );
    
        break;
    }    
}

byte crc_eprom (byte N)
{// N верхняя граница до которой считаем сумму
byte crc=0;
for (byte i = 0; i <= N; i++)
{
  crc=EEPROM.readByte(i);
}
return crc;
}
void erom_wr (byte eff1)
{
   

    switch (eff1)
    {
    case 0:
   
       EEPROM.writeByte( 1, Brightness);
       EEPROM.writeByte( 21, V); 
       EEPROM.writeByte( 23,H_min);
       EEPROM.writeByte( 24, H_max);
       EEPROM.writeByte( 25 , S_min );
       EEPROM.writeByte( 26 , S_max );
       EEPROM.writeFloat( 37 , speedK_min );
       EEPROM.writeFloat( 53 , speedK_max );
        break;
    
    case 1:
       EEPROM.writeByte( 2, Brightness  );
       EEPROM.writeByte( 11, BrightnessRGB );
       EEPROM.writeFloat( 29 ,  Tcollor_min );
       EEPROM.writeFloat( 33 ,  Tcollor_max ) ; 
       EEPROM.writeFloat( 41 , speedK_min  );
       EEPROM.writeFloat( 57 , speedK_max );
        break;

    case 2:
        EEPROM.writeByte( 3,Brightness );
        EEPROM.writeByte( 12 , BrightnessRGB );
        EEPROM.writeFloat( 72 , speedR ) ;
        EEPROM.writeFloat( 76 , speedG );
        EEPROM.writeFloat( 80 , speedB );
       
            break;
    case 3:
        EEPROM.writeByte( 4 , Brightness );
        EEPROM.writeByte( 13 , BrightnessRGB );
        EEPROM.writeFloat( 45 , speedK_min );
        EEPROM.writeFloat( 61 , speedK_max );
        break;

    case 4:
        EEPROM.writeByte( 5 , Brightness);
        EEPROM.writeByte( 14 , BrightnessRGB);
        EEPROM.writeFloat( 49 , speedK_min );
        EEPROM.writeFloat( 65 , speedK_max);
        break;
    case 5:
         EEPROM.writeByte( 6 , Brightness);
         EEPROM.writeByte( 18 , H );
         EEPROM.writeByte( 20 , S );
         EEPROM.writeByte( 22 , V );
    
        break;
    case 6:
        EEPROM.writeByte( 7 , Brightness);
        EEPROM.writeByte( 15 , BrightnessRGB );
        EEPROM.writeByte( 69 , R );
        EEPROM.writeByte( 70 , G );
        EEPROM.writeByte( 71 , B );
    
        break;
    case 7:
        EEPROM.writeByte( 8 , Brightness );
        EEPROM.writeByte( 16 , BrightnessRGB );
        EEPROM.writeInt( 27 , Temp );
        break;
        
    case 8:
        EEPROM.writeByte( 9 , Brightness );
        EEPROM.writeByte( 86 , BrightnessRGB );
        EEPROM.writeInt ( 84 , Color );
    
        break;
    }
}