#include <Arduino.h>
// ------ Драйвер ------
#define HIGH_FREQUENCY 0    // 0 - 490 Гц, 1 - 7.8 кГц, 2 - 31.4 кГц, 3 - ручная настройка
#define PWM_FREQUENCY 15000 // частота ШИМ на настройке №3, Герц
#define DRIVER_DIRECTION 0  // 0 - обычный (мосфеты), 1 - реверс (LED amplifier)

// ------ Энкодер ------
#define USE_ENC 1           // 1 - использовать энкодер, 0 - нет
#define ENC_REVERSE 0       // 1 - инвертировать направление энкодера
#define ENC_TYPE 0          // 0 или 1 - тип энкодера

// ------ Кнопка -------
#define USE_BTN 1           // 1 - использовать кнопку, 0 - нет
// #define BTN_MODE 0          // режим работы кнопки: 0 - переключение пресетов, 1 - переключение цветов
//
#define USE_BT 1
// --------- Цвет ---------
#define MIN_PWM 1           // минимальный сигнал PWM
// #define GAMMA_BRIGHT 1      // гамма-коррекция яркости
// #define LUT_R 1.0           // коэффициент LUT матрицы красного цвета (0.0 - 1.0)
// #define LUT_G 1.0           // коэффициент LUT матрицы зелёного цвета (0.0 - 1.0)
// #define LUT_B 1.0           // коэффициент LUT матрицы синего цвета (0.0 - 1.0)

// драйвер
#define PIN_R 3
#define PIN_G 9
#define PIN_B 10
#define PIN_W 11

// энкодер
#define CLK 6
#define DT 8
#define SW 7
// кнопка. сзади 5, с лица 2
#define BTN 2
#define LED_PIN 4 // светодиод
//Колличество режимов
#define N_eff 9
#define N_contr 4
#define EPROM_CONTR 98 // для очистки памяти поменять на другое



#include <EEPROMex.h>
#include <GyverRGB.h>
GRGB diode(PIN_R, PIN_G, PIN_B);  // куда подключены цвета (R, G, B)

#include <GyverEncoder.h>
Encoder enc(CLK, DT, SW);

#include <GyverButton.h>
GButton btn(BTN);


int8_t eff=0 ; // режим вывода
byte contr=1 ; // режим управления энкодором, что меняем
byte  Brightness = 200; // яркость белого канала
byte  BrightnessRGB =250 ;
byte  H = 150;
byte  S = 200;
byte  V = 230;
byte  H_min=0;
byte  H_max=250;
byte  S_min=150;
byte  S_max=255;
int Temp=1010;
float Tcollor_min=100;
float Tcollor_max=1000;
// настройки режимов
float speedK_min=100 ;// длительность цикла мС
float speedK_max=1000;
byte  R=200;
byte  G=50;
byte  B=70;
uint32_t Timer=0, TimerR=0, TimerG=0, TimerB=0;
float speedTemp=500; // 100 - 1000
float speedR=123;
float speedG=256;
float speedB=59;
int Color=0 ;

bool napr=true ;
bool naprS=true ;
bool naprR=true ;
bool naprG=true ;
bool naprB=true ;
bool naprSp=false;
bool hdiod=true;
bool eeprom_wr=false;
byte P_svdiod=0;
bool btnControl = true;
bool LEDon = true;
byte xx=1;

void setup() {
   if (USE_BT) Serial.begin(9600);
  // инициализируем светодиод и показиваем что питание есть
  pinMode(LED_PIN, OUTPUT);
  digitalWrite(LED_PIN, HIGH);
  // put your setup code here, to run once:
  //pinMode(PIN_R, OUTPUT);
  //pinMode(PIN_G, OUTPUT);
  //pinMode(PIN_B, OUTPUT);
  pinMode(PIN_W, OUTPUT);
  diode.setMinPWM(MIN_PWM);

// btn.setStepTimeout(150);
btn.setClickTimeout(900);

  

 // ------ ЛЕНТА -------
  // выставляем режим и частоту ШИМ
  if (HIGH_FREQUENCY == 1) {
    TCCR1B |= _BV(WGM12);
    TCCR1B = TCCR1B & 0b11111000 | 0x02;
    TCCR2A |= _BV(WGM20) | _BV(WGM21);
    TCCR2B = TCCR2B & 0b11111000 | 0x02;
  } else if (HIGH_FREQUENCY == 2) {
    TCCR1B &= ~_BV(WGM12);
    TCCR1B = TCCR1B & 0b11111000 | 0x01;
    TCCR2A |= _BV(WGM20);
    TCCR2B = TCCR2B & 0b11111000 | 0x01;
  } else if (HIGH_FREQUENCY == 3) {
    diode.highFrequency(PWM_FREQUENCY);
  }


// ------ ЭНКОДЕР -------
  enc.setType(TYPE1);

// Проверяем память и при первом включении записываем
if ( crc_eprom(90) !=EEPROM.readByte(100) or EEPROM.readByte(99)!= EPROM_CONTR)
{
  def_set ();
  EEPROM.writeByte(100, crc_eprom(90));
  EEPROM.writeByte(99, EPROM_CONTR);
  P_svdiod=30;
}
eff = EEPROM.readByte(0);

if (eff > N_eff)
{
  eff=0;
  EEPROM.writeByte(0, 0);
};
erom_read ();
}

void loop() {
  
 if (btnControl ) controlTick();    // отработка управления если не блокировано ВТ
 if (LEDon ) effectsTick(); else {
    digitalWrite(PIN_R, LOW);
    digitalWrite(PIN_G, LOW);
    digitalWrite(PIN_B, LOW);
    digitalWrite(PIN_W, LOW); }    // вывод режимов если не выключено
#if (USE_BT == 1)
bluetoothTick();
#endif
 sv_diod();
  
}